OPT OSVERSION=37
OPT PREPROCESS,REG=5


LIBRARY 'poland.telecard',
         1,1,
        '$VER: poland.telecard 1.1 (15.07.98) 1998, Piotr Gapinski' IS tcInfo


/*
 *    poland.telecard
 *    1998, Piotr Gapiski
 *
 *    obsuguje tylko karty 128 bitowe
 *
 */


MODULE '*telecards','*/protocols/protocols',
       'tools/installhook','utility/hooks','exec/nodes'


  DEF hook:hook
  DEF card:cardInfo


PROC main() IS EMPTY
PROC tcInfo()
  installhook(hook,{dispatcher})
  card.name      := 'Poland'
  card.memory    := 128
  card.protocol  := 'ISO7816-2'
  card.ver       := 1
  card.rev       := 2
  card.cs        := NIL
  card.hook      := hook
  card.copyright := '1998,1999, Piotr Gapinski,\nAdam <jayx@box43.gnet.pl>'
ENDPROC card


PROC dispatcher(hook:PTR TO hook,buffer:PTR TO CHAR,msg:PTR TO cardMsg)
  DEF rc=TRUE,command

  VOID hook
  command:=msg.command
  SELECT command
    CASE CARD_IDENT;        rc:=ident(buffer,msg)
    CASE CARD_UNITS;        rc:=units(buffer,msg)
    CASE CARD_MANUFACTURER; rc:=manufacturer(buffer,msg)
  DEFAULT
    rc:=FALSE
  ENDSELECT
ENDPROC rc


->- identyfikacja karty
->- metoda zwraca TRUE gdy identyfikacja zakoczya si sukcesem
->-
PROC ident(buffer:PTR TO LONG,args:PTR TO cardIdent)
  DEF id,rc=TRUE,size

  id:=(buffer[] AND $FFFFFF00)
  SELECT id
    CASE $E92E6400    ->- karta 128bit
  DEFAULT
    rc:=FALSE
  ENDSELECT
  size:=args.size
  IF (rc) THEN ^size:=128
ENDPROC rc


->- okrelanie iloci wolnych jednostek
->- metoda zwraca TRUE gdy identyfikacja zakoczya si sukcesem
->-
PROC units(buffer:PTR TO CHAR,args:PTR TO cardUnits)
  DEF left,nominal
  DEF un,ula,ulb

  ->- inicjalizacja
  ->-
  un  := args.un
  ula := args.ulHi
  ulb := args.ulLo

  ->- wyznaczanie jednostek nominalnych
  ->-
  nominal:=50

  ->- wyznaczanie jednostek pozostaych na karcie (counter 5-cio bajtowy)
  ->- zabezpieczenie przed przypadkowymi bdami
  ->-
  left:=(bits(buffer[11])*8)+bits(buffer[12])
  IF (left<0) THEN RETURN FALSE

  ^un:=nominal
  ^ula:=left
  ^ulb:=NIL
ENDPROC TRUE


->- okrelanie producenta karty
->- metoda zwraca TRUE gdy identyfikacja zakoczya si sukcesem
->-
PROC manufacturer(buffer:PTR TO CHAR,args:PTR TO cardManufacturer)
  DEF p

  VOID buffer
  p:=args.id
  ^p:='OTO Lublin'
ENDPROC TRUE
